### Ядро для построения telegram ботов на Python.

Позволяет написать бота любой сложности, не погружаясь в устройство telegram. Доступно даже **начинающим** изучать
python программистам.

Достаточно написать только логику бота и поставить на свой сервер.

Ядро полностью **имплементирует все ограничения** telegram для ботов, вашего бота никогда не забанят.

Основные функции ядра:

+ рассылка сообщений всем подписчикам бота
+ автоматическое уведомление админов бота об ошибках времени исполнения
+ запись всех входящих и исходящих сообщений в базу SQLite
+ высокоскоростное кэширование исходящих сообщений с сохранением их порядка.
+ подробный отладочный лог или лог основных событий в продакшене
+ сбор статистики работы для админа

Структура проекта:
**magic.py** - исполняемый файл бота, загружает все остальное.  
**main_module.py** - основной модуль бота (их может быть несколько), место для вашего кода.  
**bot_io.py** - модуль ввода-вывода (сообщений).  
**bot_io_classes.py** - классы модуля ввода-вывода.  
**tg_utils.py** - классы и функции telegram для всех модулей.  
**magic.ini** - файл конфигурации бота.

Инструкция по развертыванию на сервере (ubuntu) находится в файле **install.md**  
Инструкция по настройкам находится в файле **config.md**

Бот использует библиотеку [Telethon].

Благодарности, вопросы и реквесты фич складывать здесь или в комментариях к [этому посту].

Лицензия на код и документацию MIT. Вы можете свободно использовать, изменять и продавать код при условии сохранения
информации об авторских правах.

[Telethon]:https://docs.telethon.dev/en/latest/

[этому посту]:https://t.me/ssleg/347